From b9bf5e7aec27404f3a6684fd8a7297c283170f9d Mon Sep 17 00:00:00 2001
From: David Cattermole <cattermole91@gmail.com>
Date: Jan 03 2021 08:00:06 +0000
Subject: [PATCH 2028/2232] Force annotation on all functions in both source and header files


Annotations for symbol visibility (such as `__declspec(dllexport)` and
`__attribute__((visibility("default")))`) is the primary use case.
Such annotations are expected to be needed on declarations (headers)
only, however forcing the annotations into the header file only
is causes missing symbols. Therefore the fix is to force the
annotations into both declaration (header files) and definition
(source files).

---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 2404f9c..a2ce630 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -910,6 +910,7 @@ fn write_rust_function_shim_decl(
     sig: &Signature,
     indirect_call: bool,
 ) {
+    begin_function_definition(out);
     write_return_type(out, &sig.ret);
     write!(out, "{}(", local_name);
     for (i, arg) in sig.args.iter().enumerate() {
@@ -947,9 +948,6 @@ fn write_rust_function_shim_impl(
         // We've already defined this inside the struct.
         return;
     }
-    if !out.header {
-        begin_function_definition(out);
-    }
     write_rust_function_shim_decl(out, local_name, sig, indirect_call);
     if out.header {
         writeln!(out, ";");

